unit EADOFieldsEditor;

{
Author     : Guy Smith-Ferrier
Date       : February 2000
Description:
This unit contains TEADODataSetEditor which is the Enhanced Fields Editor for
all of the ADO datasets.

}

interface

uses
  EDSFieldsEditor, ADOReg, ADODB, DSDesign, DsgnIntf;

type
  TEADODataSetEditor = class(TADODataSetEditor)
  protected
    function GetDSDesignerClass: TDSDesignerClass; override;
  end;

  procedure Register;

implementation

function TEADODataSetEditor.GetDSDesignerClass: TDSDesignerClass;
begin
  Result := TEDSDesigner
end;

procedure Register;
begin
  RegisterComponentEditor(TADODataSet, TEADODataSetEditor);
end;

end.
